//+------------------------------------------------------------------+
//|                                        TREND TRADER BY AUTHE.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http: //www.metaquotes.net"
#property show_inputs
//-------------------------------------------------------------------
extern int P = 20, TakeProfit = 50, Max, slipage = 30, X = 15, Margin = 100;
extern double LOT = 0.1;
datetime time0 = 0;
//-------------------------------------------------------------------
bool UseSound      = True;              //   
string NameFileSound = "expert.wav";    //   
color clOpenBuy     = LightBlue;        //   BuyStop
color clOpenSell    = LightCoral;       //   SellStop
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
	//----

	//----
	return (0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
	//----

	//----
	return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
	bool hangingman = Hanging_man(), hammer = Hammer(), uptrend = Uptrend(), downtrend = Downtrend();
	int Free = AccountFreeMargin();

	if (time0 != Time[0]) {
		//-------------------------------------------------------------------
		while (true) {
			if (Free < Margin)
				break;
			//--------------------------------------
			while (true) {
				if (hangingman != true)
					break;else
				if (uptrend == true)
					SELL() ;
				int Ticket = SELL();
				if (Ticket < 0)
					Repeatsell(Ticket);
				break;
			}
			//--------------------------------------
			while (true) {
				if (hammer != true)
					break;else
				if (downtrend == true)
					BUY();
				int Ticket1 = BUY();
				if (Ticket1 < 0)
					Repeatbuy(Ticket);
				break;
			}
		}
	}
	time0 = Time[0];
	//----

	//----
	return (0);
}


//+-----------------------------------------------------------------------------+
//+----------USER DEFINE--------------------------------------------------------+

int BUY()
{
	datetime exp;
	color clOpen = clOpenBuy;
	string lsComm = GetCommentForOrder();
	double pAsk = High[1] + P * Point; double Stoploss = High[1] - Low[1];
	double Idstop = pAsk - Stoploss + 20 * Point; double Idtake = pAsk + TakeProfit * Point;
	int D = (High[1] - Low[1]) / Point;

	exp = Time[0] + X * 180;
	if (D > Max)
		return (-1);else
		OrderSend(Symbol(), OP_BUY, LOT, pAsk, slipage, Idstop, Idtake, lsComm, 0, exp, clOpen);
	if (UseSound) PlaySound(NameFileSound);
	int Ticket2 = OrderSend(Symbol(), OP_BUY, LOT, pAsk, slipage, Idstop, Idtake);

	if (Ticket2 > 0)
		return (Ticket2);else
		return (-1);
}
//+--------------------------------------------------------------------------------+
//+--------------USER DEFINE-------------------------------------------------------+
int SELL()
{
	datetime exp;
	color clOpen = clOpenSell;
	string lsComm = GetCommentForOrder();
	double pBid = Low[1] - P * Point; double Stoploss = High[1] - Low[1];
	double Idstop = pBid - Stoploss + 20 * Point; double Idtake = pBid + TakeProfit * Point;
	int D = (High[1] - Low[1]) / Point;

	exp = Time[0] + X * 180;

	if (D > Max)
		return (-1);else
		int Ticket3 = OrderSend(Symbol(), OP_SELL, LOT, pBid, slipage, Idstop, Idtake, lsComm, 0, exp, clOpen);
	if (UseSound) PlaySound(NameFileSound);
	if (Ticket3 > 0)
		return (Ticket3);else
		return (-1);
}

//+-------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------+
bool Hanging_man()
{
	double H = High[1], L = Low[1], O = Open[1], C = Close[1];

	if (((H - O) / (O - C) >= 2.5 && (C - O) / (O - L) >= 0.7) || ( ((H - O) / (O - C)) >= 2.5 && (C - L) == 0))
	{ return (true); } else {
		if (((H - C) / (C - O) >= 2.5 && (C - O) / (O - L) >= 0.7) || ( ((H - C) / (C - O)) >= 2.5 && (O - L) == 0))
		{ return (true); }
	}
	return (false);
}
//+--------------------------------------------------------------------------------+
//+--------------------------------------------------------------------------------+
bool Hammer()
{
	double H = High[1], L = Low[1], O = Open[1], C = Close[1];
	if ((((C - L) / (O - C)) >= 2.5 && (O - C) / (H - O) >= 0.7)  || ( ((C - L) / (O - C)) >= 2.5 && (H - O) == 0))
	{ return (true); } else
	{ if (((O - L) / (C - O) >= 2.5 && (C - O) / (H - C) >= 0.7) || ( ((O - L) / (C - O)) >= 2.5 && (H - C) == 0))
	  { return (true); } }
	return (false);
}
//+-----------------------------------------------------------------------------------+
//+-----------------------------------------------------------------------------------+
bool Uptrend() {
	if ((High[1] > High[2] > High[3] > High[4]) || (Low[1] > Low[2] > Low[3] > Low[4])) return (true);return (false);
}
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
bool Downtrend() {
	if ((High[1] < High[2] < High[3] < High[4]) || (Low[1] < Low[2] < Low[3] < Low[4]))
		return (true);
	return (false);
}
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
void Repeatbuy(int ticket) {
	while (true) {
		BUY();
		ticket = BUY();
		if (ticket < 0)
			BUY();
		ticket = BUY();
		if (ticket < 0)
			break;
	}
}

//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
void Repeatsell(int ticket) {
	while (true) {
		SELL();
		ticket = SELL();
		if (ticket < 0)
			SELL();
		ticket =  BUY();
		if (ticket < 0)
			break;
	}
}
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
string GetCommentForOrder(){
	return;
}